#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire500four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 500"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire500four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four5004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2four5004xi = {
                1:'101x-478y102z',
                2:'105x-100y478z',
                3:'106x-197y446z',
                4:'114x-97y476z',
                5:'119x-195y444z',
                6:'122x-94y475z',
                7:'126x-473y97z',
                8:'131x-192y442z',
                9:'131x-90y473z',
                10:'133x-282y390z',
                11:'140x-85y472z',
                12:'144x-188y440z',
                13:'148x-80y470z',
                14:'149x-278y387z',
                15:'151x-467y93z',
                16:'156x-184y437z',
                17:'156x-74y468z',
                18:'164x-68y467z',
                19:'166x-273y384z',
                20:'169x-178y435z',
                21:'172x-61y465z',
                22:'176x-459y88z',
                23:'179x-53y463z',
                24:'181x-172y432z',
                25:'182x-267y380z',
                26:'184x-343y312z',
                27:'187x-44y461z',
                28:'193x-165y430z',
                29:'193x-35y459z',
                30:'198x-260y377z',
                31:'199x-26y457z',
                32:'200x-450y83z',
                33:'203x-336y308z',
                34:'205x-158y427z',
                35:'205x-16y455z',
                36:'210x-5y453z',
                37:'214x-252y374z',
                38:'216x-149y424z',
                39:'222x-327y304z',
                40:'224x-440y78z',
                41:'227x-140y422z',
                42:'229x-243y370z',
                43:'238x-130y419z',
                44:'241x-317y300z',
                45:'245x-234y367z',
                46:'247x-428y73z',
                47:'248x-119y416z',
                48:'258x-107y414z',
                49:'259x-223y364z',
                50:'259x-307y296z',
                51:'25x-485y117z',
                52:'267x-95y411z',
                53:'269x-415y68z',
                54:'273x-211y360z',
                55:'276x-82y408z',
                56:'277x-295y292z',
                57:'284x-68y405z',
                58:'287x-199y357z',
                59:'291x-401y63z',
                60:'291x-54y402z',
                61:'294x-282y288z',
                62:'297x-39y399z',
                63:'29x-22y498z',
                64:'300x-185y353z',
                65:'303x-24y396z',
                66:'308x-8y393z',
                67:'311x-268y284z',
                68:'312x-385y58z',
                69:'313x-171y350z',
                70:'324x-156y346z',
                71:'327x-253y280z',
                72:'332x-369y53z',
                73:'335x-140y342z',
                74:'33x-95y489z',
                75:'342x-237y276z',
                76:'345x-123y339z',
                77:'34x-23y498z',
                78:'351x-351y48z',
                79:'354x-106y335z',
                80:'356x-220y272z',
                81:'363x-88y331z',
                82:'370x-203y268z',
                83:'370x-333y43z',
                84:'370x-70y328z',
                85:'377x-51y324z',
                86:'382x-184y263z',
                87:'382x-31y320z',
                88:'386x-11y316z',
                89:'387x-313y38z',
                90:'394x-165y259z',
                91:'403x-293y33z',
                92:'40x-24y497z',
                93:'40x-98y488z',
                94:'418x-271y28z',
                95:'432x-249y23z',
                96:'445x-226y18z',
                97:'456x-203y13z',
                98:'466x-179y8z',
                99:'46x-24y497z',
                100:'475x-154y3z',
                101:'47x-100y487z',
                102:'485x-174y306z',
                103:'50x-484y112z',
                104:'51x-24y496z',
                105:'55x-102y486z',
                106:'57x-23y496z',
                107:'63x-103y485z',
                108:'63x-22y495z',
                109:'69x-20y494z',
                110:'71x-103y483z',
                111:'75x-17y494z',
                112:'76x-482y107z',
                113:'79x-103y482z',
                114:'80x-14y493z',
                115:'81x-198y451z',
                116:'86x-11y492z',
                117:'88x-103y481z',
                118:'91x-7y491z',
                119:'94x-198y449z',
                120:'96x-101y479z',
                121:'96x-2y490z'}
#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire500four4xi" usage = "target function for charge5004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire500four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE500FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE500FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE500FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE500FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE500FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four5004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE500FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE500FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE500FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four5004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four5004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE500FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE500FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE500FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire500four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                    